=== debian/changelog ===
monado (21.0.0~dfsg1-2ubuntu2) jammy; urgency=medium

  * No-change rebuild against libopencv-core4.5d

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 08 Dec 2021 03:09:03 +0000

monado (21.0.0~dfsg1-2ubuntu1) jammy; urgency=medium

  * debian/patches/glibc-2.34.patch: compatibility with glibc 2.34.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 07 Dec 2021 07:38:35 +0000

monado (21.0.0~dfsg1-2) unstable; urgency=medium

  * d/control
    - Add Build-Depends on libbsd-dev for pidfile support when
      building service.
    - Bump Standards-Version to 4.6.0, no changes required.
    - Remove Build-Depends that we don't actually use.
    - Exclude some dependencies on less-common arches to fix builds.
  * d/copyright: Update
  * Backport patch for upstream to fix FTBFS, closes: #997239
  * Clean up/annotate patches
  * Switch to pandoc from markdown for formatting changelog.

 -- Ryan Pavlik <ryan@ryanpavlik.com>  Tue, 26 Oct 2021 16:59:16 -0500

monado (21.0.0~dfsg1-1) unstable; urgency=medium

  * New upstream version 21.0.0~dfsg1
  * Fix gbp.conf for sid.
  * Exclude bitmap icons for SteamVR driver due to unclear
    license/source
  * Disable building new SteamVR driver.
  * d/control
    - Fix Vcs- fields for sid
    - Update metadata based on conformance results
    - Update Standards-Version to 4.5.1 - no changes required.
    - Add Build-Depends on gstreamer for video-file support
  * d/copyright: Update
  * Drop 0001-Fix-destdir-repetition-with-systemd-unit.patch:
    merged upstream.
  * Add patch to allow overriding package version
  * d/rules: Provide the Debian version to the build

 -- Ryan Pavlik <ryan@ryanpavlik.com>  Thu, 11 Feb 2021 15:36:12 -0600

monado (0.3.0-3) unstable; urgency=medium

  * Source-only upload.

 -- Andrew Lee (李健秋) <ajqlee@debian.org>  Sat, 18 Jul 2020 07:58:47 +0800

monado (0.3.0-2) experimental; urgency=medium

  * Adjust build to use service-enabled mode on Linux.
    - Adds a patch to fix systemd unit install location
    - Adds a new binary package, monado-service, on Linux.

 -- Ryan Pavlik <ryan@ryanpavlik.com>  Tue, 14 Jul 2020 16:01:24 -0500
