=== debian/control ===
Source: monado
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Ryan Pavlik <ryan@ryanpavlik.com>
Uploaders: Andrew Lee (李健秋) <ajqlee@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 12),
               cmake,
               glslang-tools,
               libavcodec-dev [!hppa !sh4],
               libbsd-dev [linux-any],
               libcjson-dev,
               libdbus-1-dev [linux-any],
               libegl1-mesa-dev,
               libeigen3-dev,
               libgl1-mesa-dev,
               libglvnd-dev,
               libgstreamer1.0-dev,
               libgstreamer-plugins-base1.0-dev,
               libhidapi-dev [!hurd-i386],
               libopencv-dev [!alpha !ia64 !sparc64 !x32],
               libsystemd-dev [linux-any],
               libsdl2-dev,
               libudev-dev,
               libusb-1.0-0-dev,
               libuvc-dev,
               libv4l-dev,
               libvulkan-dev,
               libwayland-dev,
               libx11-dev,
               libx11-xcb-dev,
               libxcb-randr0-dev,
               libxrandr-dev,
               libxxf86vm-dev,
               pandoc <!nodoc>,
               pkg-config
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/monado-team/monado/-/tree/debian/sid
Vcs-Git: https://salsa.debian.org/monado-team/monado.git -b debian/sid
Homepage: https://monado.freedesktop.org/
Rules-Requires-Root: no

Package: monado-service
Architecture: linux-any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: xr-hardware,
            libopenxr-loader1,
            libopenxr1-monado (= ${binary:Version})
Description: Monado XR hardware and composition service
 Monado is an open-source package for interacting with virtual and
 augmented reality (collectively known as XR) hardware and software.
 .
 This package provides the service that provides the VR compositor and
 hardware drivers to Monado clients like libopenxr1-monado.

Package: libopenxr1-monado
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends},
         monado-service (= ${binary:Version}) [linux-any]
Recommends: xr-hardware,
            libopenxr-loader1
Suggests: bluez [linux-any]
Provides: libopenxr1
Description: Monado implementation of the OpenXR API
 Monado is an open-source package for interacting with virtual and
 augmented reality (collectively known as XR) hardware and software.
 .
 This package provides a runtime that aims to be a complete and conforming
 implementation of the OpenXR API from Khronos. When used with the
 "simulated" device driver, this package is conformant with OpenXR 1.0.
 When used with any other driver, this package is based on a published
 Khronos Specification and is expected to pass the Khronos Conformance
 Process. Current conformance status can be found at
 www.khronos.org/conformance.

Package: monado-cli
Architecture: any
Section: graphics
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: xr-hardware
Description: Monado command-line utility
 Monado is an open-source package for interacting with virtual and
 augmented reality (collectively known as XR) hardware and software.
 .
 This package provides a command line utility that can be used to test
 probing for XR hardware.

Package: monado-gui
Architecture: any
Section: graphics
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: xr-hardware
Description: Monado GUI config and debug utility
 Monado is an open-source package for interacting with virtual and
 augmented reality (collectively known as XR) hardware and software.
 .
 This package provides a graphical interface utility that can be used to
 test probing for XR hardware, as well as performing calibration of
 cameras for use in tracking.
